 <?php
/*
Plugin Name: BillyBenRing
Plugin URI: http://www.etherocliquecite.eu
Description: BillyBenRing display your links, tag and/or categories by a circlar sideBar widget, with full or arrowed circles. Fully customizable.
Author: Billyben
Version: 2.2.1
Author URI: http://asblog.etherocliquecite.eu
*/

/* inclu les utilitaires */
include_once("elm/utilsClasse.php");//fct util
include_once("elm/bbr_widget_class.php");//la classe du widget
include_once("elm/bbr_bd_manager.php");// les fonction de gestion de la bd
include_once("elm/bbr_options_class.php");// les fonction de gestion de la bd

// les variables globales
$bbr_new_version = '2.2.1';
if (!defined('BBR_VERSION_KEY'))define('BBR_VERSION_KEY', 'bbr_version');
if (!defined('BBR_VERSION_NUM'))define('BBR_VERSION_NUM', $bbr_new_version);
if (!defined('BBR_TEXT_DOMAIN'))define('BBR_TEXT_DOMAIN', 'bbr_widget_text');
// on met à jour la table selon la version
function bbr_check_version(){
	if(get_option('bbr_version')==BBR_VERSION_NUM)return;
	if(!get_option('bbr_options')){
		$options= bbr_init_options(array());
		add_option('bbr_options', $options);
		update_option('bbr_options', $options);		
		$wid_opt=bbr_init_single_widget_options(array());		
		$widAllOpt=array('lastId'=>0, 'allId'=>array(), "0"=>$wid_opt);
		add_option('bbr_widget_opt', $widAllOpt);
		update_option('bbr_widget_opt', $widAllOpt);		
		add_option('bbr_version', BBR_VERSION_NUM);
		update_option('bbr_version', BBR_VERSION_NUM);
		return;
	}
	if(!get_option('bbr_version')){
			bbr_fill_table_with_older_version();
			bbr_add_checked_to_colors();
			bbr_add_position_to_widget();
			 add_option('bbr_version', BBR_VERSION_NUM);
			 update_option('bbr_version', BBR_VERSION_NUM);
			 return;
		}
		
	$vers=get_option('bbr_version');
	$mainVer=substr($vers, 0,1);
	$subVer=substr($vers, 2,1);
	if($mainVer!=2){
			bbr_fill_table_with_older_version();
			bbr_add_checked_to_colors();
			bbr_add_position_to_widget();
			update_option('bbr_version', BBR_VERSION_NUM);
			return;
		}
	if($subVer!=2){
			bbr_add_checked_to_colors();
			bbr_add_position_to_widget();
			update_option('bbr_version', BBR_VERSION_NUM);
			return;
		}
	update_option('bbr_version', BBR_VERSION_NUM);
}
function bbr_create_option_page(){
	$page=new bbr_Theme_Options();	

}
//
function bbr_install () {
	bbr_check_version();
	$options=get_option('bbr_options');
	$options= bbr_init_options($options);
	update_option('bbr_options', $options);	
}
function bbr_uninstall(){
	//delete_option('bbr_options');
}


function BillyBenRing_widget()
{ 
	bbr_check_version();
  	register_widget("BillyBenRing");
}


add_action("widgets_init", "BillyBenRing_widget");
add_action('wp_loaded' , 'bbr_create_option_page');
register_activation_hook( __FILE__, 'bbr_install' );
register_deactivation_hook( __FILE__, 'bbr_uninstall' );
add_shortcode( 'BBR', 'bbr_shortcodehandler' );

?>
