/*   JQUery functions 
______________________________________ */

jQuery(document).ready(function($) {
			if($.browser.mozilla)$("form").attr("autocomplete", "off");
			var wrapped = $(".wrap h3").wrap("<div class=\"ui-tabs-panel\">");
			wrapped.each(function() {
				$(this).parent().append($(this).parent().nextUntil("div.ui-tabs-panel"));
			});
			$(".ui-tabs-panel").each(function(index) {
				var str = $(this).children("h3").text().replace(/\s/g, "_");
				$(this).attr("id", str.toLowerCase());
				if (index > 0)
					$(this).addClass("ui-tabs-hide");
			});
			$(".ui-tabs").tabs({ fx: { opacity: "toggle", duration: "fast" } });
			
			$("input[type=text], textarea").each(function() {
				if ($(this).val() == $(this).attr("placeholder") || $(this).val() == "")
					$(this).css("color", "#999");
			});
			
			$("input[type=text], textarea").focus(function() {
				if ($(this).val() == $(this).attr("placeholder") || $(this).val() == "") {
					$(this).val("");
					$(this).css("color", "#000");
				}
			}).blur(function() {
				if ($(this).val() == "" || $(this).val() == $(this).attr("placeholder")) {
					$(this).val($(this).attr("placeholder"));
					$(this).css("color", "#999");
				}
			});
			$(".wrap h3, .wrap table").show();
			// update des preview
			$('.bbr_updateFlashPreview').click(function(){
				var flash=$(this).closest('table').find("object")[0];
				//flash.update_widget("ok");
				var table=$(this).closest('div').find('.form-table');
				
				var width=table.find('input[id=width]').val();
				var height=table.find('input[id=height]').val();
				var flashCont=$(this).closest('table').find("object");
				flashCont.attr("width", width);
				flashCont.attr("height", height);
				
				var flashVar=new Array();
				table.find("select,input").each(function(){
					var id=$(this).attr("id");
					var val=$(this).val();
					flashVar.push({name:id, value:val});
				});
				table.find('input[type=radio]:checked').each(function(){
					var id=$(this).attr("id");
					id=id.substring(0, id.length-1);					
					var val=$(this).val();
					flashVar.push({name:id, value:val});				
				});
				var str=makeObjectFormArray(flashVar);
				flash.update_widget(str);
				
				
			});
		
			// pour la page
			var GET = bbr_getQueryParams(document.location.search);
			if(GET['page']!='bbr-options')return;			
			
			// pour le sortable
			
			$(".form-table tbody").attr("class", "ui-body-cont-sort");
			$(".ui-body-cont-sort").each(function(){
				$(this).sortable();
				$(this).bind( "sortstop", bbr_sort_end);
			});
			$(".to_ft").attr("class", "form-table");
			function bbr_sort_end(event, ui){
				var parentId=ui.item.parent().parent().parent().attr("id");
				bbr_renumber_table(parentId);				
			}
			// pour le select all
			$(".selectAll_CB").each(function(){
				verifyAllChecked($(this));
				$(this).bind("change", selectAllChange);
			});
			function selectAllChange(event, ui){
				var table=$(this).closest('table').next('table');
				var cbs=table.find(".col_sel");//table.children(".col_sel");
				cbs.attr('checked',$(this).is(':checked'));
			}
			function verifyAllChecked(el){
				var table=el.closest('table').next('table');
				var cbs=table.find(".col_sel");//table.children(".col_sel");
				var allChk=true;
				cbs.each(function (){
					if(!$(this).is(':checked'))allChk=false;
				});
				el.attr('checked',allChk);
			}
		});
function makeObjectFormArray(arr){
	var str='';
	for (var i=0; i<arr.length; i++){
			var el=arr[i];
			str+=el.name+"-#-"+el.value+'###';
	}
	return str;
	
}
function bbr_renumber_table(tableId){
	var prefix="";
	switch(tableId){
		case "link_color" :
			prefix="link";
			break;
		case "category_color" :
			prefix="cat";
			break;
		case "tag_color" :
			prefix="tag";
			break;
		case "page_color" :
			prefix="page";
			break
	}
	var table=document.getElementById(tableId);
	var posEle= bbr_get_posel(table);
	var numCol=posEle.length;
	
	for(var i=0; i<numCol; i++){
		var el=posEle[i];
		el.value=i;
	}
	
}
function bbr_get_posel(table){
	var inputEl=table.getElementsByTagName("input");
	var arr=new Array();
	for (var i=0; i<inputEl.length; i++){
			var el=inputEl[i];
			if(el.type=="hidden"&&el.className=="col_pos")arr.push(el);
		}
	return arr;	
}
function bbr_getQueryParams(qs) {
    qs = qs.split("+").join(" ");
    var params = {},
        tokens,
        re = /[?&]?([^=]+)=([^&]*)/g;

    while (tokens = re.exec(qs)) {
        params[decodeURIComponent(tokens[1])]
            = decodeURIComponent(tokens[2]);
    }

    return params;
}

/* pour la previw flassh des widget */
	












/* end Jquery 
__________________ */


function currentWidgetHasChange(ele){
	document.getElementById('bbreraseWidget').type="submit";
	var ref=ele.href
	var str=ref.substring(ref.lastIndexOf("_")+1);
	document.getElementById('bbr_idOfCurrentWidget').value=str;
}
function bbr_confirmErase(quote){
	var id=document.getElementById('bbr_idOfCurrentWidget').value;
	var agree=window.confirm(quote+" Widget_"+id);
	if (agree){
		return true ;
	}else{
		return false ;
	}
}
/* validation formulaires
_____________________________________ */
function bbr_validateRingForm(form){
	
	var validate=true;
	var alertString="";
	var inputs=form.getElementsByTagName("input");
	for(var i = 0; i < inputs.length; i++) {
		var el=inputs[i];
		if (el.type!='text')continue;
		var value=el.value;
		//if(el.className=='regular-text color')alert(el.className+"  :  "+value.length+" / "+(el.className=='regular-text color'&&value.length!=6));
		if(el.className=='regular-text color'&&value.length!=6){
			bbr_add_error_mess(el, " Invalid Color");
			validate=false;
		}
		if(el.className!='regular-text color'&&(isNaN(value)||value.length<1)){
			bbr_add_error_mess(el, " Invalid Number");
			validate=false;
		}		
	}
	if(!validate)alert("Incorrect Values\n bad values are quoted in red")
	return validate;
}
function bbr_add_error_mess(el, string){
	var mess=document.createElement('span');
	mess.name="mess";
	mess.innerHTML=string;
	mess.setAttribute("style", "color:#FF0000;");
	el.parentNode.insertAfter(mess, el);	
}

/*
###########
*/
function say_ok(){
	alert("ok");
	}
function bbr_createGradient(el){
	var tableId="";
	var prefix="";
	switch(el.id){
		case "linkGradientButton" :
			tableId="link_color";
			prefix="link";
			break;
		case "catGradientButton" :
			tableId="category_color";
			prefix="cat";
			break;
		case "tagGradientButton" :
			tableId="tag_color";
			prefix="tag";
			break;
		case "pageGradientButton" :
			tableId="page_color";
			prefix="page";
			break
	}
	var table=document.getElementById(tableId);
	var col1=HexToRGB(document.getElementById(prefix+"Gradient1").value);
	var col2=HexToRGB(document.getElementById(prefix+"Gradient2").value);
	
	var colorEle=get_color_element_from_table(table, prefix);
	var numCol=colorEle.length;
	var dr=(col1["r"]-col2["r"])/(numCol-1);
	var dg=(col1["g"]-col2["g"])/(numCol-1);
	var db=(col1["b"]-col2["b"])/(numCol-1);
		
	for(var i=0; i<numCol; i++){
		var el=colorEle[i];
		var colHex=RGBtoHex(col1["r"]-i*dr,col1["g"]-i*dg, col1["b"]-i*db); 
		el.color.fromString(colHex);
	}
}
function HexToRGB(hexVal){
	var h=(hexVal.charAt(0)=="#")?hexVal.substring(1,6):hexVal;
	var rgbArr=new Array();
	var r=parseInt(h.substring(0,2),16);
	var g=parseInt(h.substring(2,4),16);
	var b=parseInt(h.substring(4,6),16);
	rgbArr["r"]=r;rgbArr["g"]=g;rgbArr["b"]=b;
	return rgbArr;
}
function RGBtoHex(R,G,B) {
	return toHex(R)+toHex(G)+toHex(B);
}
function toHex(N) {
	 if (N==null) return "00";
	 N=parseInt(N); if (N==0 || isNaN(N)) return "00";
	 N=Math.max(0,N); N=Math.min(N,266); N=Math.round(N);
	 return "0123466689ABCDEF".charAt((N-N%16)/16) + "0123466689ABCDEF".charAt(N%16);
}
function get_color_element_from_table(table, prefix){
		var inputEl=table.getElementsByTagName("input");
		var subPre=prefix+"_id";
		var long=subPre.length;
		var arr=new Array();
		for (var i=0; i<inputEl.length; i++){
			var el=inputEl[i];
			
			if(el.type=="text"&&el.id.substring(0,long)==subPre&&el.id!=prefix+"Gradient1"&&	el.id!=prefix+"Gradient2"&&el.className!="col_pos")
					{var id=el.id+"_sel";
						var cb=document.getElementById(id);
						if(cb.checked)arr.push(el);
					}
		}
		return arr;		
	}
	
	
	
/* ______________________________________ */
Node.prototype.insertAfter = function(noeudAInserer, noeudDeReference) {
	if(noeudDeReference.nextSibling) {
		return this.insertBefore(noeudAInserer, noeudDeReference.nextSibling);
	} else {
		return this.appendChild(noeudAInserer);
	}
}