<?php
/**
 * BillyBenRing Class
 */
class BillyBenRing extends WP_Widget {
	
	
    /** constructor */
    function BillyBenRing($id_base = false, $name= 'BillyBenRing', $widget_options = array(), $control_options = array()) {
		//bbr_check_version();
        parent::WP_Widget(false, $name = 'BillyBenRing');	
    }

    function widget($args, $instance, $specialOpt=array()) {
		
			
        extract( $args );
		$options=bbr_get_widget_options_from_id($instance['wid']);
		if (isset($specialOpt)&&count($specialOpt)>0){
			$options=wp_parse_args($specialOpt, $options);
		}
		
		
		$options= bbr_init_single_widget_options($options);
		$general_opt=bbr_init_options(get_option('bbr_options'));
       if(isset($instance['title'])) $title = apply_filters('widget_title', $instance['title']);
		// pour le swfObjet
		  $wSize=$options['width'];
		  $hSize=$options['height'];
		  $path=get_bloginfo('wpurl')."/wp-content/plugins/BillyBenRing/" ;
		  // creation des flash var
		  $flashVar['ringSize']=$options['ringSize'];
		  $flashVar['firstRingSize']=$options['firstRingSize'];
		  $flashVar['transparent']=$options['transparent'];
		  if(!$options['transparent'])$flashVar['bgColor']=$options['bgColor'];
		  $flashVar['txtOffColor']= $options['txtOffColor'];
		  $flashVar['txtOnColor']= $options['txtOnColor'];
		  $flashVar['overGlowColor']= $options['overGlowColor'];
		  $flashVar['deltaRing']= $options['deltaRing'];
		  $flashVar['RingCrop']= $options['RingCrop'];
		  $flashVar['startAlign']=$options['startAlign'];		 
		  $flashVar['startAngle']=$options['startAngle'];
		  $flashVar['decalAngle']=$options['decalAngle'];
		  $flashVar['textAlign']= $options['textAlign'];
		  $flashVar['circlePos']= $options['circlePos'];
		  
		  $flashVar['link_dest']= $general_opt['link_dest'];
		  $flashVar['cat_dest']= $general_opt['cat_dest'];
		  $flashVar['tag_dest']= $general_opt['tag_dest'];
		  $flashVar['page_dest']= $general_opt['page_dest'];
		   
		  
		  $flashVar['xmlString']=bbr_getXML_String($options);
		  
		  // la string html
		  $flashHTML='';
		  if(isset($before_widget))$flashHTML=$before_widget;
		  if ( isset($title) )$flashHTML.=$before_title . $title . $after_title;
		  $flashHTML.='<script type="text/javascript" src="'.$path.'elm/js/swfobject.js"></script>
		<script type="text/javascript">
			var flashvars ='.json_encode($flashVar).';';
	$flashHTML.='var params = {allowScriptAccess:"always"};
			params.scale="exactfit";';
	if($options['transparent']){
			$flashHTML.='params.wmode="transparent";';
	}else{		
	$flashHTML.='params.bgcolor="#'.$options['bgColor'].'";';
	}
	$flashHTML.='var attributes = {};';
	$flashHTML.='attributes.align ="'.(isset($instance['align'])?$instance['align']:"middle").'";';
	$flashHTML.='attributes.id = "'.$this->get_field_id('flashContentId').'";
			swfobject.embedSWF("'.$path.'BillyBenRing.swf", "'.$this->get_field_id('flashContentId').'", "'.$wSize.'", "'.$hSize.'", "10.0.0", false, flashvars, params, attributes);';
	
		$flashHTML.='</script>';
	$flashHTML.=' <div id="'.$this->get_field_id('flashContentId').'">';
	 $flashHTML.='<div id="'.$this->get_field_id('myAlternativeContent').'">	  
			<a href="http://www.adobe.com/go/getflashplayer">
				<img src="http://www.adobe.com/images/shared/download_buttons/get_flash_player.gif" alt="Get Adobe Flash player" />
			</a>
		</div></div>';        
		 if(isset($before_widget))$flashHTML.=$after_widget;
		echo  $flashHTML;
    }

    function update($new_instance, $old_instance) {				
		$instance = $old_instance;
		foreach($new_instance as $key=>$value){
			$instance[$key] = strip_tags($new_instance[$key]);
		}		
		$instance['displayLink']=($new_instance['displayLink'])?true:false;
		$instance['displayLinkTag']=(strip_tags($new_instance['displayLinkTag']))?true:false;
		$instance['displayCat']=(strip_tags($new_instance['displayCat']))?true:false;
		$instance['displayKeyWord']=(strip_tags($new_instance['displayKeyWord']))?true:false;
		$instance['displayPage']=(strip_tags($new_instance['displayPage']))?true:false;
		$instance['transparent']=(!strip_tags($new_instance['transparent']))?true:false;
		return $instance;
    }

    function form($options) {
		bbr_check_version();				
        $title = esc_attr($options['title']);	
		$options=bbr_init_single_widget_options($options);	
		$pageStr='<p>
          <label for='.$this->get_field_id('title').'>'._e('Title:').'</label> 
          <input class="widefat" id="'.$this->get_field_id('title').'" name="'.$this->get_field_name('title').'" type="text" value="'.$title.'" />
        </p>';
		$ids=bbr_get_ids();
		$pageStr.='<p> <label>'.__('Choose BBR Id').'</label>';
		$pageStr.='<select name="'.$this->get_field_name('wid').'">';	
		foreach($ids as $key=>$value)$pageStr.=	'<option value='.$value.' '.(($options['wid']==$value)?"selected=selected":"").'>'.$value.'</option>';
		$pageStr.='</select></p>';
		
	   
	    echo $pageStr;    
    }
} // class BillyBenRing

/* pour les shortcode
___________________________________ */
function bbr_shortcodehandler($atts){
	extract( $atts );
	
	if($align!='left'&&$align!='middle'&&$align!='right')$align='middle';
	$instOpt['wid']=$id;
	if($align)$instOpt['align']=$align;
	//
	if(isset($atts['align']))unset($atts['align']);
	unset($atts['id']);
	//
	$atts=bbr_transform_attribute_to_option($atts);
	// gestion id unique
	$number="sc_".floor(lcg_value()*1000);
	// widget
	$widget=new BillyBenRing();
	$widget->_set($number);
	$widget->widget(array(), $instOpt, $atts);	
	
}

?>