<?php
function bbr_say($str){
	echo'<script> alert("'.$str.'"); </script>';
}
/* Utilitaire pour retrouver les cat/ link et keywords
*/
function bbr_get_bookmark_arr(){
	$catArr=array();
	$cats = get_terms('link_category');
	foreach ( (array) $cats as $cat ) {
		$catName=$cat->name;
		$catArr[$catName]= get_bookmarks(array('category'=>$cat->term_id));	
	}
	return $catArr;
}
function bbr_get_bookmark_arr_order(){
	$arr=array();
	$options = get_option( 'bbr_options' );
	$cats= bbr_get_bookmark_arr();
	foreach (  $cats as $catName=>$bookmarks ) {
		  foreach($bookmarks as $bm){
			  $posId="link_id_".$bm->link_id."_pos";
			  $bm->catName=$catName;
			  (isset($options[$posId]))?$arr[$options[$posId]]=$bm:$arr[]=$bm;
			}		  
	 	 }
		ksort($arr);
		return $arr;
}
function bbr_get_bookmark_tag_arr(){
	$catArr=array();
	$cats = get_terms('link_category');
	foreach ( (array) $cats as $cat ) {
		$catName=$cat->name;
		$catArr[$catName]= $cat->term_id;	
	}
	return $catArr;
}
function bbr_get_category_arr(){
	return get_categories();
}
function bbr_get_category_arr_order(){
	$arr=array();
	$options = get_option( 'bbr_options' );
	$cats= bbr_get_category_arr();
	foreach($cats as $cat){
		$posId="cat_id_".$cat->term_id."_pos";
		(isset($options[$posId]))?$arr[$options[$posId]]=$cat:$arr[]=$cat;
	}
	ksort($arr);
	return $arr;
}
function bbr_get_page_arr(){
	$catArr=array();
	$cats = get_pages();
	foreach ( (array) $cats as $cat ) {
		$catName=$cat->post_title;
		$link = get_page_link( intval($cat->ID));
		$catArr[]=Array("id"=>$cat->ID, "link"=>$link, "name"=>$catName);
	}
	return $catArr;
}
function bbr_get_page_arr_order(){
	$arr=array();
	$options = get_option( 'bbr_options' );
	$cats=  bbr_get_page_arr();
	foreach ( $cats as  $tag ) {
		$posId="page_id_".$tag["id"]."_pos";
		(isset($options[$posId]))?$arr[$options[$posId]]=$tag:$arr[]=$tag;
	}
	ksort($arr);
	return $arr;
}

function bbr_get_keywords_arr(){
	$tags = get_terms('post_tag');
	$keyArr=array();
	foreach ( $tags as $key => $tag ) {
		$link = get_term_link( intval($tag->term_id), $tag->taxonomy );
		$keyArr[$tag->name]=array("link"=>$link, "id"=>$tag->term_id);	
	}
	return $keyArr;
}

function bbr_get_keywords_arr_order(){
	$arr=array();
	$options = get_option( 'bbr_options' );
	$cats=  bbr_get_keywords_arr();
	foreach ( $cats as $key => $tag ) {
			$posId="tag_id_".$tag["id"]."_pos";
			$tag["tagName"]=$key;
			(isset($options[$posId]))?$arr[$options[$posId]]=$tag:$arr[]=$tag;
	}
	ksort($arr);
	return $arr;
}

function bbr_init_single_widget_options($options){
	$options['width'] = (isset($options['width']))?$options['width']:'300';
	$options['height'] = (isset($options['height']))?$options['height']:'300';
	$options['ringSize'] = (isset($options['ringSize']))?$options['ringSize']:15;
	$options['firstRingSize']= (isset($options['firstRingSize']))?$options['firstRingSize']:20;
	$options['displayLink']=(isset($options['displayLink']))?$options['displayLink']:true;
	$options['displayLinkTag']=(isset($options['displayLinkTag']))?$options['displayLinkTag']:true;
	$options['displayCat']=(isset($options['displayCat']))?$options['displayCat']:false;
	$options['displayKeyWord']=(isset($options['displayKeyWord']))?$options['displayKeyWord']:false;
	$options['displayPage']=(isset($options['displayPage']))?$options['displayPage']:false;
	$options['transparent']=(isset($options['transparent']))?$options['transparent']:true;
	$options['bgColor']=(isset($options['bgColor']))?$options['bgColor']:"CCCCCC";
	$options['txtOffColor']=(isset($options['txtOffColor']))?$options['txtOffColor']:"CCCCCC";
	$options['txtOnColor']=(isset($options['txtOnColor']))?$options['txtOnColor']:"FFFFFF";
	$options['overGlowColor']=(isset($options['overGlowColor']))?$options['overGlowColor']:"FFFFFF";
	$options['deltaRing']=(isset($options['deltaRing']))?$options['deltaRing']:2;
	$options['RingCrop']=(isset($options['RingCrop']))?$options['RingCrop']:"FIT";
	$options['startAlign']=(isset($options['startAlign']))?$options['startAlign']:"DECAL";
	$options['startAngle']=(isset($options['startAngle']))?$options['startAngle']:0;
	$options['decalAngle']=(isset($options['decalAngle']))?$options['decalAngle']:0;
	$options['textAlign']=(isset($options['textAlign']))?$options['textAlign']:0;
	$options['circlePos']=(isset($options['circlePos']))?$options['circlePos']:0;
	return $options;

}

function bbr_init_options($options){	
	
	$options['bbr_currLang']=(isset($options['bbr_currLang']))?$options['bbr_currLang']:"En";
	$options['link_dest']=(isset($options['link_dest']))?$options['link_dest']:"_blank";
	$options['cat_dest']=(isset($options['cat_dest']))?$options['cat_dest']:"_self";
	$options['tag_dest']=(isset($options['tag_dest']))?$options['tag_dest']:"_self";
	$options['page_dest']=(isset($options['page_dest']))?$options['page_dest']:"_self";
	$options['display']=(isset($options['display']))?$options['display']:"bbr_link_table";
	
	$options['short_id']=(isset($options['short_id']))?$options['short_id']:0;
	$options['bbr_currLang']=(isset($options['bbr_currLang']))?$options['bbr_currLang']:'en';
	
	// init des couleur
	//les liens
	$defaultColor="CCCCCC";
	$cats = bbr_get_bookmark_arr();
	$i=0;
	foreach (  $cats as $catName=>$bookmarks ) {
		  foreach($bookmarks as $bm){
			  $catId="link_id_".$bm->link_id;
			  $options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
			  $options[$catId."_pos"]=(isset($options[$catId."_pos"]))?$options[$catId."_pos"]:$i;
			  $options[$catId."_sel"]=(isset($options[$catId."_sel"]))?$options[$catId."_sel"]:true;
			  $i++;
			}		  
	 	 }
	$i=0;
	$cats=bbr_get_category_arr();
	foreach($cats as $cat){
		$catId="cat_id_".$cat->term_id;
		 $options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
		  $options[$catId."_pos"]=(isset($options[$catId."_pos"]))?$options[$catId."_pos"]:$i;
		  $options[$catId."_sel"]=(isset($options[$catId."_sel"]))?$options[$catId."_sel"]:true;
			  $i++;
	}
	$i=0;
	$cats=bbr_get_keywords_arr();
	foreach ( $cats as $key => $tag ) {
		$catId="tag_id_".$tag["id"];
		$options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
		 $options[$catId."_pos"]=(isset($options[$catId."_pos"]))?$options[$catId."_pos"]:$i;
		 $options[$catId."_sel"]=(isset($options[$catId."_sel"]))?$options[$catId."_sel"]:true;
			  $i++;		
	}
	$cats =  bbr_get_bookmark_tag_arr();
	foreach (  $cats as $catName=>$catIDs ) {
		$catId="link_cat_id_".$catIDs;
		$options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;
	}
	$i=0;
	$cats=bbr_get_page_arr();
	foreach ( $cats as  $tag ) {
		$catId="page_id_".$tag["id"];
		$options[$catId]=(isset($options[$catId]))?$options[$catId]:$defaultColor;	
		 $options[$catId."_pos"]=(isset($options[$catId."_pos"]))?$options[$catId."_pos"]:$i;
		 $options[$catId."_sel"]=(isset($options[$catId."_sel"]))?$options[$catId."_sel"]:true;
			  $i++;	
	}
	return $options;
	
	
}

function bbr_get_default_id($curValue, $type){
	if(function_exists('icl_object_id')){
		$options=get_option('bbr_options');
		$curValue=icl_object_id($curValue, $type, true, $options['bbr_currLang']);	
	}
	return $curValue;	
}

// construction du xml de retour
function bbr_getXML_String($displays){
	$options=get_option('bbr_options');
	//$options= bbr_init_options($options);
	$xmlStr="<DATA>";
	// si des liens
	if(isset($displays['displayLink'])&&$displays['displayLink']){
		$cats = bbr_get_bookmark_arr_order();
		$catsId=bbr_get_bookmark_tag_arr();
		foreach (  $cats as $bm) {
			$idCat="link_id_".$bm->link_id;
			if(!isset($options[$idCat."_sel"])||!$options[$idCat."_sel"])continue;
			$catStr=(isset($displays['displayLinkTag'])&&$displays['displayLinkTag'])?'cat="'.$bm->catName.'" catColor="'.$options["link_cat_id_".$catsId[$bm->catName]].'" ':' ';
			 $xmlStr.='<ring type="link" '.$catStr.' url="'.$bm->link_url.'" color="'.$options["link_id_".$bm->link_id].'">'.$bm->link_name.'</ring>';
		}
	
	}
	
	
	// si catégory	
	if(isset($displays['displayCat'])&&$displays['displayCat']){
		$cats=bbr_get_category_arr_order();
		foreach($cats  as $cat) { 
		$id="cat_id_".$cat->term_id;
		if(!isset($options[$id."_sel"])||!$options[$id."_sel"])continue;
	
			$idCurr=bbr_get_default_id($cat->term_id, 'category');
			 $xmlStr.='<ring type="cat" color="'.$options["cat_id_".$idCurr].'" url="'.get_category_link($idCurr).'" count="'.$cat->count.'">'.$cat->name.'</ring>';
		} 	
	}
	// si tag
	if(isset($displays['displayKeyWord'])&&$displays['displayKeyWord']){
		$tags=bbr_get_keywords_arr_order();
		foreach ( $tags as $tag ) {
			$id="tag_id_".$tag["id"];
			if(!isset($options[$id."_sel"])||!$options[$id."_sel"])continue;
			$key=$tag["tagName"];
		$idCurr=bbr_get_default_id($tag["id"], 'post_tag');
			$xmlStr.='<ring type="keyword" color="'.$options["tag_id_".$idCurr].'" url="'.$tag["link"].'">'.$key.'</ring>';	
		}
	}	
	// si page
	if(isset($displays['displayPage'])&&$displays['displayPage']){
		$tags=bbr_get_page_arr_order();
		foreach ( $tags as $tag ) {
			$id="page_id_".$tag["id"];
			if(!isset($options[$id."_sel"])||!$options[$id."_sel"])continue;
			$idCurr=bbr_get_default_id($tag["id"], 'page');		
			$xmlStr.='<ring type="page" color="'.$options["page_id_".$idCurr].'" url="'.$tag["link"].'">'.$tag["name"].'</ring>';	
		}
	}	
	// on fini
	$xmlStr.="</DATA>";
	return urlencode($xmlStr);
}

function bbr_transform_attribute_to_option($atts){
	if(count($atts)<1)return $atts;
	$options=bbr_init_single_widget_options(array());
	foreach($options as $key=>$value){
		$lowerKey=strtolower($key);
		if(isset($atts[$lowerKey])){
			$atts[$key]=$atts[$lowerKey];
			if($key!=$lowerKey)unset($atts[$lowerKey]);
		}
	
	}
	return $atts;
	
}


?>